package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.i3plus.pojo.mes.model.MesWorkOrderModel;
import cn.estsh.i3plus.pojo.model.wms.WmsProductModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description:
 * @CreateDate 2024/04/16
 * @Author mingliang.li
 */
public interface IMesWorkOrderService extends IBaseMesService<MesWorkOrder> {
    @ApiOperation("查询生产版本")
    ListPager<MesProductVersion> queryMesProductVersionByPager(MesProductVersion mesProductVersion, Pager pager);

    @ApiOperation("工单导入")
    void saveMesWorkOrderExcel(List<MesWorkOrder> mesWorkOrderList);

    @ApiOperation(value = "生产报工")
    void doProductReport(MesWorkOrder mesWorkOrder);

    @ApiOperation(value = "生产报工(武汉)")
    void doProductReportExt(MesWorkOrder mesWorkOrder);

    @ApiOperation("非排序工单导入前删除")
    void deleteUnSortOrder(String organizeCode, List<String> partNoList);

    @ApiOperation("汇总工单给SAP")
    List<MesWorkOrderModel> sumMesWorkOrderQtyToSap(String organizeCode);

    @ApiOperation("ccscTest")
    List<MesWorkOrder> queryMesWorkOrderProcessToSap(String organizeCode);

    @ApiOperation("反向冲销")
    void doReportWorkReversal(WmsProductModel model);

    @ApiOperation("重新打开")
    void doReopen(String[] ids,String userName,String organizeCode);

    List<MesProductionRecord> getPreDayReportMesProductionRecord(String organizeCode , List<MesShift> mesShiftList, String  workCenterCode);

    List<MesProduceSn> getPreDayReportMesProduceSn(String organizeCode ,List<MesProductionRecord> mesProductionRecordList );

    List<MesWorkOrder> insertMesWorkOrder(List<MesProductionRecord> mesProductionRecordList,List<MesShift> mesShiftList,String organizeCode, String userName );

    void doPcnJobProductReport(List<MesProductionRecord> mesProductionRecordList,List<MesShift> mesShiftList,String organizeCode, String userName, MesWorkOrder mesWorkOrder);

}
