package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesEnumExtService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * @Description:
 * @Reference:
 * @Author: yiming.gu
 * @CreateDate:2019-05-06-9:51
 * @Modify:
 **/

@RestController
@Api(description = "MES基础数据")
@RequestMapping(MesCommonConstant.MES_YANFEN + "/base-data")
public class BaseExtDataController extends MesBaseController {

    @Autowired
    private IMesEnumExtService enumService;

    @GetMapping(value = "/enumlist")
    @ApiOperation(value = "获取MES系统所有枚举")
    public ResultBean enumlist(@RequestParam(name = "enumName") String enumName) {
        try {
            Map<String, Object> map = enumService.doGetMesEnumByEnumName(AuthUtil.getOrganize().getOrganizeCode(), enumName);
            return ResultBean.success("查询成功")
                    .setResultObject(map)
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping(value = "/enumlist-clazz")
    @ApiOperation(value = "获取MES系统所有枚举")
    public ResultBean enumlist(@RequestParam(name = "enumName") String enumName, @RequestParam(name = "className") String className) {
        try {
            Class clazz = Class.forName(className);
            Map<String, Object> map = enumService.getEnumByClazzEnum(enumName, clazz);
            return ResultBean.success("查询成功")
                    .setResultObject(map)
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping(value = "/enumlist-default")
    @ApiOperation(value = "获取MES系统所有枚举")
    public ResultBean defaultEnumlist(@RequestParam(name = "enumName") String enumName) {
        try {
            Map<String, Object> map = enumService.getEnumByClazzEnum(enumName, MesExtEnumUtil.class);
            return ResultBean.success("查询成功")
                    .setResultObject(map)
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}

