package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesEquipmentVariableService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.CsvImportUtil;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentVariable;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;

@Api(description = "设备变量属性")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesEquipmentVariable")
public class MesEquipmentVariableController extends BaseMesController<MesEquipmentVariable> {

    @Autowired
    private IMesEquipmentVariableService mesEquipmentVariableService;

    @PostMapping(value = "/import-csv")
    @ApiOperation(value = "导入数据CSV")
    public ResultBean importMesWorkOrderExcel(@RequestParam("file") MultipartFile file, @RequestParam("equipmentCode") String equipmentCode) {
        try {
            //导入csv文件
            List<Map<String, Object>> mapList = CsvImportUtil.csvImports(file);
            if (CollectionUtils.isEmpty(mapList)) {
                MesException.throwMesBusiException("导入数据不存在");
            }
            String userName = AuthUtil.getSessionUser().getUserName();
            String organizeCode = AuthUtil.getOrganize().getOrganizeCode();
            mesEquipmentVariableService.addMesEquipmentVariable(mapList, equipmentCode, userName, organizeCode);

            return ResultBean.success("导入成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
