package cn.estsh.i3plus.ext.mes.apiservice.controller.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.IMesYfReportService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : Mes业务报表
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/28 14:17
 * @Modify:
 **/
@Api("Mes业务报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/report")
public class MesBusiReportController extends MesBaseController {

    @Autowired
    private IMesYfReportService mesYfReportService;

    @ApiOperation(value = "查询追溯报表", notes = "查询追溯报表")
    @GetMapping("/traceability/find")
    public ResultBean findTraceabilityReport(MesProduceSn mesProduceSn) {
        try {
            ValidatorBean.beginValid(mesProduceSn).notNull("productSn", mesProduceSn.getProductSn());
            mesProduceSn.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            return ResultBean.success("查询成功").setResultList(mesYfReportService.findTraceabilityReport(mesProduceSn));
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
