package cn.estsh.i3plus.ext.mes.apiservice.dao.board;

import cn.estsh.i3plus.ext.mes.pojo.model.board.MesWorkCenterBoardResultModel;
import cn.estsh.i3plus.pojo.mes.bean.MesShift;

import java.util.List;

/**
 * @Description : 看板-数据方法实现
 * @Reference :
 * @Author : logic
 * @CreateDate : 2024/6/24 18:22
 * @Modify:
 **/
public interface IMesYfBoardDao {

    /**
     * 查询指定产线在当前时间节点有效的班次信息
     * @param workCenterCodeList 指定产线代码集合
     * @param organizeCode 组织代码
     * @param nowDateTime 当前时间
     * @return 指定产线在当前时间节点有效的班次信息
     */
    List<MesShift> queryMesShift(List<String> workCenterCodeList, String organizeCode, String nowDateTime);

    /**
     * 查询指定产线在指定时间区间内的生产汇报数据
     * @param workCenterCode 产线代码
     * @param organizeCode 组织代码
     * @param startTime 查询起始时间
     * @param endTime 查询结束时间
     * @return 生产汇报数据
     */
    List<MesWorkCenterBoardResultModel> queryMesProductOffLineModel(String workCenterCode, String organizeCode, String startTime, String endTime);

    /**
     * 查询指定产线在指定时间区间内的生产加工完成条码及状态
     * @param workCenterCode 产线代码
     * @param organizeCode 组织代码
     * @param startTime 查询起始时间
     * @param endTime 查询结束时间
     * @return 加工完成条码及其质量状态
     */
    List<MesWorkCenterBoardResultModel> queryCompletedSnInfo(String workCenterCode, String organizeCode, String startTime, String endTime);

}
