package cn.estsh.i3plus.ext.mes.apiservice.daoimpl;

import cn.estsh.i3plus.ext.mes.apiservice.dao.IMesBomDao;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;

/**
 * @Description : BOM信息
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/24 14:43
 * @Modify:
 **/

@Service
@Slf4j
public class MesDaoImpl implements IMesBomDao {

    @Autowired
    private EntityManager entityManager;

    @Override
    public List<String> findBomVersionByPartNo(String partNo, String organizeCode) {
        StringBuilder sql = new StringBuilder(" select distinct bomVersion from MesBom where partNo = :partNo  " +
                "and isDeleted=:isDeleted and isValid = :isValid and organizeCode = :organizeCode order by createDatetime desc");
        Query query = entityManager.createQuery(sql.toString(), String.class);
        query.setParameter("partNo", partNo);
        query.setParameter("organizeCode", organizeCode);
        query.setParameter("isValid", CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue());
        query.setParameter("isDeleted", CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
        return (List<String>) query.getResultList();
    }

    @Override
    public List<String> findBomCodeByPartNoAndBomVersion(String partNo, String bomVersion, String organizeCode) {
        StringBuilder sql = new StringBuilder(" select distinct bomCode from MesBom where partNo = :partNo  and bomVersion = :bomVersion " +
                " and isDeleted=:isDeleted and isValid = :isValid and organizeCode = :organizeCode order by createDatetime desc");
        Query query = entityManager.createQuery(sql.toString(), String.class);
        query.setParameter("partNo", partNo);
        query.setParameter("bomVersion", bomVersion);
        query.setParameter("organizeCode", organizeCode);
        query.setParameter("isValid", CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue());
        query.setParameter("isDeleted", CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
        return (List<String>) query.getResultList();
    }
}
