package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPackingDefineService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPackingDefine;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description : 包装定义维护
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/3 14:41
 * @Modify:
 **/
@Service
@Slf4j
public class MesPackingDefineServiceImpl extends BaseMesService<MesPackingDefine> implements IMesPackingDefineService {

    @Override
    protected void setPackQueryBean(MesPackingDefine bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getPackCode(), "packCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPackName(), "packName", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getCheckLotnumberFlag(), "checkLotnumberFlag", packBean);
    }

    @Override
    protected void onInsertBean(MesPackingDefine item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPackCode(), "箱类别代号不能为空");

        DdlPackBean roadPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPackCode(), "packCode", roadPackBean);

        boolean flg = baseRDao.isExitByHql(roadPackBean);
        if (flg) {
            MesException.throwMesBusiException("箱类别代号【%s】已经存在，请检查数据", item.getPackCode());
        }
    }

    @Override
    protected void onUpdateBean(MesPackingDefine item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPackCode(), "箱类别代号不能为空");


        DdlPackBean roadPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPackCode(), "packCode", roadPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", roadPackBean);
        boolean flg = baseRDao.isExitByHql(roadPackBean);
        if (flg) {
            MesException.throwMesBusiException("箱类别代号【%s】已经存在，请检查数据", item.getPackCode());
        }
    }
}
