package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProductionRecordService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesProductionRecord;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * @Description : 设备加工记录表
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/28 9:27
 * @Modify:
 **/
@Service
@Slf4j
public class MesProductionRecordServiceImpl extends BaseMesService<MesProductionRecord> implements IMesProductionRecordService {

    @Override
    public List<MesProductionRecord> findMesProductionRecord(String organizeCode, String sn) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(sn, "productSn", packBean);
        DdlPreparedPack.getOrderBy("createDatetime", CommonEnumUtil.ASC_OR_DESC.ASC.getValue(),packBean);
        List<MesProductionRecord> produceSnList = baseRDao.findByHqlWhere(packBean);
        if (CollectionUtils.isEmpty(produceSnList)) {
            MesException.throwMesBusiException("条码【%s】加工记录信息不存在", sn);
        }
        return produceSnList;
    }
}
