package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderToSapService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderToSap;
import cn.estsh.i3plus.pojo.mes.model.MesWorkOrderModel;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.Objects;

@Service
@Slf4j
public class MesWorkOrderToSapServiceImpl extends BaseMesService<MesWorkOrderToSap> implements IMesWorkOrderToSapService {

    @Override
    public MesWorkOrderToSap insert(MesWorkOrderModel mesWorkOrder) {
        MesWorkOrderToSap mesWorkOrderToSap = new MesWorkOrderToSap(mesWorkOrder.getOrganizeCode(),
                mesWorkOrder.getOrganizeCode(), mesWorkOrder.getPartNo(), mesWorkOrder.getProductVersion(),
                mesWorkOrder.getQty(), mesWorkOrder.getPlanStartTime());
        ConvertBean.serviceModelUpdate(mesWorkOrderToSap,mesWorkOrder.getModifyUser());
        return baseRDao.insert(mesWorkOrderToSap);
    }

    @Override
    public void doMesWorkOrder(String organizeCode,List<MesWorkOrderModel> mesWorkOrderList) {
        Pager pager = new Pager(1,1);
        DdlPackBean ddlPackBean = null;
        for (MesWorkOrderModel mesWorkOrder : mesWorkOrderList) {
            mesWorkOrder.setOrganizeCode(organizeCode);
            mesWorkOrder.setModifyUser("job");
            //计划开始时间+物料查询发送Sap的数据
            ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
            DdlPreparedPack.getStringEqualPack(mesWorkOrder.getPlanStartTime(),"pedtr",ddlPackBean);
            DdlPreparedPack.getStringEqualPack(mesWorkOrder.getPartNo(),"plmat",ddlPackBean);
            ddlPackBean.setOrderByStr(" order by createDatetime desc ");
            List<MesWorkOrderToSap> workOrderToSapList = baseRDao.findByHqlPage(ddlPackBean,pager);
            if(CollectionUtils.isEmpty(workOrderToSapList)){
                insert(mesWorkOrder);
            }else{
                if(!Objects.equals(workOrderToSapList.iterator().next().getGsmng(),mesWorkOrder.getQty())){
                    insert(mesWorkOrder);
                }
            }
        }
    }
}
