package cn.estsh.i3plus.ext.mes.pojo.model.board;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

/**
 * @Description : 产线看板-查询结果封装
 * @Reference :
 * @Author : logic
 * @CreateDate : 2024/6/19 15:26
 * @Modify:
 **/
@Data
@ApiModel("产线看板-查询结果封装")
public class MesWorkCenterBoardResultModel {

    /**
     * 查询产线状态
     */
    @ApiParam(value = "产线代码")
    private String workCenterCode;

    @ApiParam(value = "产线状态")
    private Integer workCenterCodeStatus;

    /**
     * 查询产线生产完成率
     */
    @ApiParam(value = "产线完成数")
    private Double workCenterCompletedQuantity;

    @ApiParam(value = "产线计划数")
    private Double workCenterPlannedQuantity;

    @ApiParam(value = "产线完成率")
    private Double workCenterCompletionRate;

    /**
     * 查询产线工单完成情况
     */
    @ApiParam(value = "工单号")
    private String workOrderNo;

    @ApiParam(value = "零件号")
    private String partNo;

    @ApiParam(value = "零件描述")
    private String partDescription;

    @ApiParam(value = "工单完成数")
    private Double workOrderCompletedQuantity;

    @ApiParam(value = "工单计划数")
    private Double workOrderPlannedQuantity;

    @ApiParam(value = "工单一次合格率")
    private Double workOrderFirstPassRate;

    /**
     * 查询单位小时完工数
     */
    @ApiParam(value = "单位小时完工数目标值")
    private Double unitHourCompletionRateTargetValue;

    @ApiParam(value = "单位小时完工数")
    private Integer unitHourCompletionRate;

    @ApiParam(value = "单位小时完工数-时间段")
    private String unitHourCompletionRateTimePeriod;

    /**
     * 查询产线一次下线合格率
     */
    @ApiParam(value = "产线一次下线合格率")
    private Double workCenterFirstTimeOfflineQualificationRate;

    @ApiParam(value = "产线一次下线合格率-时间段")
    private String workCenterFirstTimeOfflineQualificationRateTimePeriod;

    /**
     * 查询点检结果
     */
    @ApiParam(value = "点检项")
    private String inspectionItems;

    @ApiParam(value = "点检结果")
    private Integer inspectionResults;

    /**
     * 查询异常停线时间
     */
    @ApiParam(value = "异常停机时间")
    private String abnormalDowntime;

    /**
     * 查询sql结果
     */
    @ApiParam(value = "过程条码")
    private String serialNumber;

    @ApiParam(value = "创建时间")
    private String createDateTime;

    @ApiParam(value = "质量状态")
    private Integer qcStatus;

    public MesWorkCenterBoardResultModel() {
    }

    public MesWorkCenterBoardResultModel(String serialNumber, String createDateTime) {
        this.serialNumber = serialNumber;
        this.createDateTime = createDateTime;
    }

}
