package cn.estsh.i3plus.ext.mes.pojo.model.report;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesWcEquipment;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.util.List;

@Data
@ApiModel("工位扫描日志合并设备日志报表-查询条件封装")
public class MesWorkCellScanMonitorConditionModel {

    @ApiParam(value = "表标识, 1=monitor 2=logdetail")
    private Integer flag;

    @ApiParam(value = "组织代码")
    private String organizeCode;

    @ApiParam(value = "产线")
    private String workCenterCode;

    @ApiParam(value = "工位")
    private String workCellCode;

    @ApiParam(value = "设备ID")
    private Integer equipId;

    @ApiParam(value = "设备代码")
    private String equipmentCode;

    @ApiParam("设备变量ID")
    private Long equipVariableId;

    @ApiParam("设备变量名称")
    private String equipVariableName;

    @ApiParam("开模记录ID")
    private Long mouldRecordId;

    @ApiParam("扫描/读取信息")
    private String scanInfo;

    @ApiParam("生产工单号")
    private String workOrderNo;

    @ApiParam("零件条码")
    private String productSn;

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("工步代码")
    private String stepCode;

    @ApiParam("日志类型")
    private String logTypes;

    @ApiParam("信息类型")
    private Integer messageType;

    @ApiParam("查询条数")
    private Integer limit;

    @ApiParam("查询时间正序或倒叙")
    private Integer ascOrDesc = CommonEnumUtil.ASC_OR_DESC.DESC.getValue();

    @ApiParam("查询时间起始")
    private String createDateTimeStart;

    @ApiParam("查询时间截止")
    private String createDateTimeEnd;

    @ApiParam("日志类型")
    private List<Integer> logTypeList;

    public MesWorkCellScanMonitorConditionModel copy(MesWorkCellScanMonitorConditionModel conditionModel) {
        BeanUtils.copyProperties(conditionModel, this);
        return this;
    }

    public MesWorkCellScanMonitorConditionModel location(MesWcEquipment wcEquipment) {
        this.workCenterCode = wcEquipment.getWorkCenterCode();
        this.workCellCode = wcEquipment.getWorkCellCode();
        this.equipmentCode = wcEquipment.getEquipmentCode();
        return this;
    }

    public MesWorkCellScanMonitorConditionModel equipId(Integer equipId) {
        this.equipId = equipId;
        return this;
    }

    public MesWorkCellScanMonitorConditionModel flag(Integer flag) {
        this.flag = flag;
        return this;
    }

    public MesWorkCellScanMonitorConditionModel logTypeList(List<Integer> logTypeList) {
        this.logTypeList = logTypeList;
        return this;
    }


}
